[DP] HDU 1024 Max Sum Plus Plus

Max Sum Plus Plus


Problem Description
Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem.

Given a consecutive number sequence S 1, S 2, S 3, S 4 ... S x, ... S n (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ S x ≤ 32767). We define a function sum(i, j) = S i + ... + S j (1 ≤ i ≤ j ≤ n).

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i 1, j 1) + sum(i 2, j 2) + sum(i 3, j 3) + ... + sum(i m, j m) maximal (i x ≤ i y ≤ j x or i x ≤ j y ≤ j x is not allowed).

But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(i x, j x)(1 ≤ x ≤ m) instead. ^_^
 

Input
Each test case will begin with two integers m and n, followed by n integers S 1, S 2, S 3 ... S n.
Process to the end of file.
 

Output
Output the maximal summation described above in one line.
 

Sample Input
 
 
1 3 1 2 3
2 6 -1 4 -2 3 -2 3
 

Sample Output
 
 
6
8


【题目大意】发现网上没有个正经的翻译,我一开始就是题意理解错误,一直不能AC。题目的意思是这样的:给你一段由n个数组成的数组,请你从中抽取m段数,使这m段数之和最大。( 求n个元素数组的m段连续子段和的最大值

【题解】

dp[i][j]=前j个数选择i段的最大值

状态转移:dp[i][j]=max(dp[i][j-1]  ,  max{dp[i-1][k]}  )+a[j]  (i-1<=k<=j-1)

第J个元素可以和前面的连接在一起,构成i段,或者独自成为一段,

如果是独自成为一段的话,那么前j-1个数必须组合出i-1段,选择多种情况里的最大值,

【状态压缩】由于数据较大,但是我们发现,每一次状态转移至用到了d[i][]和d[i-1][],所以我们直接去掉i这一维,用pre[]保留d[i-1]

//看懂了记得点赞啊

#include<cstdio>  
#include<algorithm>  
#include<cmath>  
#include<cstdlib>  
#include<cstring>
#define INF 2147483640 
using namespace std;  
const int maxn=1000005;  
typedef __int64 LL;  
  
int a[maxn],dp[maxn];  
int pre[maxn];//对应递推式的第二项  
int main(){  
    int T;
    int n,m;  
    while(~scanf("%d%d",&m,&n)){  
        for(int i=1;i<=n;i++){  
            scanf("%d",a+i);  
            dp[i]=pre[i]=0;  
        }  
        int mx;  
        dp[0]=pre[0]=0;  
        for(int i=1;i<=m;i++){  
            mx=-INF;  
            for(int j=i;j<=n;j++){  
                dp[j]=max(dp[j-1],pre[j-1])+a[j];  //dp[i][j]=max{dp[i][j-1],dp[i-1][k]}+a[j];
                pre[j-1]=mx;  
                mx=max(dp[j],mx);  
            }  
        }  
        printf("%d\n",mx);  
    }  
    return 0;  
}  
https://blog.csdn.net/u013167299/article/details/44703807
我是参考了这位大佬的程序


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值